<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/xtend/CppUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.xtend;
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.OperationUtils;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.ITextTemplate;
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterDirectionKind;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.ListExtensions;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/xtend/CppUtils.html">CppUtils</a> <strong class="jxr_keyword">implements</strong> ITextTemplate {
<a class="jxr_linenumber" name="L20" href="#L20">20</a>    <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_javadoccomment">   * create the C++ signature for an operation (including parenthesis)</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence cppSignature(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L24" href="#L24">24</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L25" href="#L25">25</a>      String _name = operation.getName();
<a class="jxr_linenumber" name="L26" href="#L26">26</a>      _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L27" href="#L27">27</a>      _builder.append(<span class="jxr_string">"("</span>);
<a class="jxr_linenumber" name="L28" href="#L28">28</a>      {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>        EList&lt;Parameter&gt; _ownedParameters = operation.getOwnedParameters();
<a class="jxr_linenumber" name="L30" href="#L30">30</a>        <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>        <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Parameter parameter : _ownedParameters) {
<a class="jxr_linenumber" name="L32" href="#L32">32</a>          <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>            _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>          } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L35" href="#L35">35</a>            _builder.appendImmediate(<span class="jxr_string">", "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L36" href="#L36">36</a>          }
<a class="jxr_linenumber" name="L37" href="#L37">37</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L38" href="#L38">38</a>          CharSequence _cppParameter = CppUtils.cppParameter(parameter);
<a class="jxr_linenumber" name="L39" href="#L39">39</a>          _builder.append(_cppParameter, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L40" href="#L40">40</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L41" href="#L41">41</a>        }
<a class="jxr_linenumber" name="L42" href="#L42">42</a>      }
<a class="jxr_linenumber" name="L43" href="#L43">43</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>    }
<a class="jxr_linenumber" name="L45" href="#L45">45</a>    
<a class="jxr_linenumber" name="L46" href="#L46">46</a>    <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">   * make a C++ call, pass all parameters except the return parameter</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence cppCall(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      String _name = operation.getName();
<a class="jxr_linenumber" name="L52" href="#L52">52</a>      _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L53" href="#L53">53</a>      _builder.append(<span class="jxr_string">"("</span>);
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>        EList&lt;Parameter&gt; _parametersNonRet = OperationUtils.parametersNonRet(operation);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>        <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>        <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Parameter parameter : _parametersNonRet) {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>          <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>            _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>          } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>            _builder.appendImmediate(<span class="jxr_string">", "</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>          }
<a class="jxr_linenumber" name="L63" href="#L63">63</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>          String _name_1 = parameter.getName();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>          _builder.append(_name_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L67" href="#L67">67</a>          _builder.append(<span class="jxr_string">"\t\t"</span>);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>        }
<a class="jxr_linenumber" name="L69" href="#L69">69</a>      }
<a class="jxr_linenumber" name="L70" href="#L70">70</a>      _builder.append(<span class="jxr_string">")"</span>);
<a class="jxr_linenumber" name="L71" href="#L71">71</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L72" href="#L72">72</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>    }
<a class="jxr_linenumber" name="L74" href="#L74">74</a>    
<a class="jxr_linenumber" name="L75" href="#L75">75</a>    <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">   * make a C++ call, pass all parameters except the return parameter, prefix with "return",</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">   * if there is a return type in the operations declaration</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence returnCppCall(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L81" href="#L81">81</a>      {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>        Type _type = operation.getType();
<a class="jxr_linenumber" name="L83" href="#L83">83</a>        <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_type, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L84" href="#L84">84</a>        <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>          _builder.append(<span class="jxr_string">"return "</span>);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>        }
<a class="jxr_linenumber" name="L87" href="#L87">87</a>      }
<a class="jxr_linenumber" name="L88" href="#L88">88</a>      CharSequence _cppCall = CppUtils.cppCall(operation);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>      _builder.append(_cppCall, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L90" href="#L90">90</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L91" href="#L91">91</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L92" href="#L92">92</a>    }
<a class="jxr_linenumber" name="L93" href="#L93">93</a>    
<a class="jxr_linenumber" name="L94" href="#L94">94</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence cppParameter(<strong class="jxr_keyword">final</strong> Parameter parameter) {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L96" href="#L96">96</a>      Type _type = parameter.getType();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>      _builder.append(_type, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>      {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>        ParameterDirectionKind _direction = parameter.getDirection();
<a class="jxr_linenumber" name="L100" href="#L100">100</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_direction, Integer.valueOf(ParameterDirectionKind.OUT));
<a class="jxr_linenumber" name="L101" href="#L101">101</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a>         _builder.append(<span class="jxr_string">"_out"</span>);
<a class="jxr_linenumber" name="L103" href="#L103">103</a>       }
<a class="jxr_linenumber" name="L104" href="#L104">104</a>     }
<a class="jxr_linenumber" name="L105" href="#L105">105</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L106" href="#L106">106</a>     String _name = parameter.getName();
<a class="jxr_linenumber" name="L107" href="#L107">107</a>     _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L108" href="#L108">108</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L109" href="#L109">109</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L110" href="#L110">110</a>   }
<a class="jxr_linenumber" name="L111" href="#L111">111</a>   
<a class="jxr_linenumber" name="L112" href="#L112">112</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence cppType(<strong class="jxr_keyword">final</strong> Type type) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L114" href="#L114">114</a>     {
<a class="jxr_linenumber" name="L115" href="#L115">115</a>       String _qualifiedName = type.getQualifiedName();
<a class="jxr_linenumber" name="L116" href="#L116">116</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_qualifiedName, <span class="jxr_string">"UMLPrimitiveTypes::Boolean"</span>);
<a class="jxr_linenumber" name="L117" href="#L117">117</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a>         _builder.append(<span class="jxr_string">"bool"</span>);
<a class="jxr_linenumber" name="L119" href="#L119">119</a>         _builder.newLine();
<a class="jxr_linenumber" name="L120" href="#L120">120</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L121" href="#L121">121</a>         String _qualifiedName_1 = type.getQualifiedName();
<a class="jxr_linenumber" name="L122" href="#L122">122</a>         <strong class="jxr_keyword">boolean</strong> _equals_1 = Objects.equal(_qualifiedName_1, <span class="jxr_string">"UMLPrimitiveTypes::Integer"</span>);
<a class="jxr_linenumber" name="L123" href="#L123">123</a>         <strong class="jxr_keyword">if</strong> (_equals_1) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a>           _builder.append(<span class="jxr_string">"int"</span>);
<a class="jxr_linenumber" name="L125" href="#L125">125</a>           _builder.newLine();
<a class="jxr_linenumber" name="L126" href="#L126">126</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L127" href="#L127">127</a>           String _dereferenceTypedef = ElementUtils.dereferenceTypedef(type);
<a class="jxr_linenumber" name="L128" href="#L128">128</a>           _builder.append(_dereferenceTypedef, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L129" href="#L129">129</a>           _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L130" href="#L130">130</a>         }
<a class="jxr_linenumber" name="L131" href="#L131">131</a>       }
<a class="jxr_linenumber" name="L132" href="#L132">132</a>     }
<a class="jxr_linenumber" name="L133" href="#L133">133</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L134" href="#L134">134</a>   }
<a class="jxr_linenumber" name="L135" href="#L135">135</a>   
<a class="jxr_linenumber" name="L136" href="#L136">136</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence cppRetType(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L137" href="#L137">137</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L138" href="#L138">138</a>     {
<a class="jxr_linenumber" name="L139" href="#L139">139</a>       Type _type = operation.getType();
<a class="jxr_linenumber" name="L140" href="#L140">140</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_type, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a>         _builder.append(<span class="jxr_string">"void"</span>);
<a class="jxr_linenumber" name="L143" href="#L143">143</a>         _builder.newLine();
<a class="jxr_linenumber" name="L144" href="#L144">144</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L145" href="#L145">145</a>         Type _type_1 = operation.getType();
<a class="jxr_linenumber" name="L146" href="#L146">146</a>         CharSequence _cppType = CppUtils.cppType(_type_1);
<a class="jxr_linenumber" name="L147" href="#L147">147</a>         _builder.append(_cppType, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L148" href="#L148">148</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L149" href="#L149">149</a>       }
<a class="jxr_linenumber" name="L150" href="#L150">150</a>     }
<a class="jxr_linenumber" name="L151" href="#L151">151</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L152" href="#L152">152</a>   }
<a class="jxr_linenumber" name="L153" href="#L153">153</a>   
<a class="jxr_linenumber" name="L154" href="#L154">154</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">   * Open a set of C++ namespaces associated with the packages of of the passed named element</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">   * TODO: use indentTab? =&gt; requires making this script recursive</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_javadoccomment">   * Need to include referenced types (assuming a naming convention?</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence openNamespace(<strong class="jxr_keyword">final</strong> NamedElement namedElement) {
<a class="jxr_linenumber" name="L160" href="#L160">160</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L161" href="#L161">161</a>     {
<a class="jxr_linenumber" name="L162" href="#L162">162</a>       EList&lt;Namespace&gt; _usedNamespaces = ElementUtils.usedNamespaces(namedElement);
<a class="jxr_linenumber" name="L163" href="#L163">163</a>       List&lt;Namespace&gt; _reverse = ListExtensions.&lt;Namespace&gt;reverse(_usedNamespaces);
<a class="jxr_linenumber" name="L164" href="#L164">164</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Namespace ns : _reverse) {
<a class="jxr_linenumber" name="L165" href="#L165">165</a>         _builder.append(<span class="jxr_string">"namespace "</span>);
<a class="jxr_linenumber" name="L166" href="#L166">166</a>         String _name = ns.getName();
<a class="jxr_linenumber" name="L167" href="#L167">167</a>         _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L168" href="#L168">168</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L169" href="#L169">169</a>       }
<a class="jxr_linenumber" name="L170" href="#L170">170</a>     }
<a class="jxr_linenumber" name="L171" href="#L171">171</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L172" href="#L172">172</a>   }
<a class="jxr_linenumber" name="L173" href="#L173">173</a>   
<a class="jxr_linenumber" name="L174" href="#L174">174</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">   * Close a set of C++ namespaces associated with the packages of of the passed named element</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence closeNamespace(<strong class="jxr_keyword">final</strong> NamedElement namedElement) {
<a class="jxr_linenumber" name="L178" href="#L178">178</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L179" href="#L179">179</a>     {
<a class="jxr_linenumber" name="L180" href="#L180">180</a>       EList&lt;Namespace&gt; _usedNamespaces = ElementUtils.usedNamespaces(namedElement);
<a class="jxr_linenumber" name="L181" href="#L181">181</a>       <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Namespace ns : _usedNamespaces) {
<a class="jxr_linenumber" name="L182" href="#L182">182</a>         _builder.append(<span class="jxr_string">"}; // of namespace [ns.name/]"</span>);
<a class="jxr_linenumber" name="L183" href="#L183">183</a>         _builder.newLine();
<a class="jxr_linenumber" name="L184" href="#L184">184</a>       }
<a class="jxr_linenumber" name="L185" href="#L185">185</a>     }
<a class="jxr_linenumber" name="L186" href="#L186">186</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L187" href="#L187">187</a>   }
<a class="jxr_linenumber" name="L188" href="#L188">188</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
